BITS 32

SEGMENT DATA PUBLIC ALIGN=16 CLASS=DATA USE32
SEGMENT DATA

STRUCPOINTER    DD   0
REFERENCEDATA   DD   12341234H

SEGMENT CODE PUBLIC ALIGN=16 CLASS=CODE USE32
SEGMENT CODE

;EAX = POINTER TO
              SCREENPOINTER EQU 0
              SCREENBASE    EQU 4
              ALLKEYSPTR    EQU 8
              SEQPTR        EQU 12
              AUXPTR        EQU 16
              CALCULSEQPTR  EQU 20
              EVENORODD     EQU 24
              DOUBLED       EQU 28
              YCOUNT        EQU 32
              MINKEY        EQU 36
              KEYLINE       EQU 40
              NUMKEYS       EQU 44
              BLOCK16       EQU 48
              CORRADDR      EQU 52
              KEYSCOUNTADDR EQU 56
              
GLOBAL PROCVIDEOP
PROCVIDEOP:
PUSHAD
MOV [STRUCPOINTER],EAX
;
; 1) CALCUL ALL CORRELATIONS BETWEEN KEYLINE<>LINES0..286
;    SAVE TO CORRADDR AS LONGINT
;
; 2) DO NUMKEYS TIME->
;    FIND MINCORRELATION - LINENUMBER
;    SET IT TO $FFFFFFFF
;    ADD ABS(ALLKEYS[LINENUMBER,0..32767]-NUMKEYSTIME) TO KEYSCOUNT[0..32767]
;    FIND MINCORRELATION - LINENUMBER
;    SET IT TO $FFFFFFFF
;    ADD ABS(ALLKEYS[LINENUMBER,0..32767]-NUMKEYSTIME) TO KEYSCOUNT[0..32767]
;    DEC NUMKEYSTIME
;    LOOP 2
; 3) FIND FROM KEYSCOUNT[0..32767] MINIMUM VALUE -> BESTKEY
; 4) CALCULSEQUENCE(BESTKEY)
; 5) DO COLOR CORRECTION
; 6) SHOW DATA ON SCREEN USING SEQPTR SEQUENCE
;

; 1) DO ALL CORRELATIONS
;    a) esi=auxptr
;    b) edi=esi+768*keyline
;    c) ecx=287 lignes
;    d) xor ebx,ebx do correlation (esi+ebx,edi+ebx) save to corraddr
;    e) inc corraddr,4 loop d

mov esi,[eax+AUXPTR]
mov ebx,[eax+KEYLINE]
mov eax,ebx
mov ecx,768
mul ecx
mov edi,esi
add edi,eax
mov eax,[STRUCPOINTER]
mov ebx,[eax+CORRADDR]
MOV ECX,287
.DOONELINE:
PUSH ECX
;MOV ECX,[EAX+BLOCK16]
MOV ECX,48
PXOR MM7,MM7
PXOR MM6,MM6
XOR EDX,EDX
.DO16:
movq       mm0,[ESI+EDX]  ; grab 1st half of row from bptr
movq       mm1,[EDI+EDX]  ; grab 1st half of row from cptr
movq       mm2,mm0             ; make a copy for abs diff operation
movq       mm3,[ESI+EDX+8] ; grab 2nd half of row from bptr
psubusb    mm0,mm1             ; do subtraction one way (w/saturation)
psubusb    mm1,mm2             ; do subtraction the other way (w/saturation)
movq       mm4,[EDI+EDX+8] ; grab 2nd half of row from cptr
por        mm0,mm1             ; merge results of 1st half
movq       mm5,mm3             ; make a copy for abs diff operation
movq       mm1,mm0             ; keep a copy
psubusb    mm3,mm4             ; do subtraction one way (w/saturation)
punpcklbw  mm0,mm6             ; unpack to higher precision for accumulation
psubusb    mm4,mm5             ; do subtraction the other way (w/saturation)
psrlq      mm1,32              ; shift results for accumulation
por        mm3,mm4             ; merge results of 2nd half
punpcklbw  mm1,mm6             ; unpack to higher precision for accumulation
movq       mm4,mm3             ; keep a copy
punpcklbw  mm3,mm6             ; unpack to higher precision for accumulation
paddw      mm7,mm0             ; accumulate difference...
psrlq      mm4,32              ; shift results for accumulation
paddw      mm7,mm1             ; accumulate difference...
punpcklbw  mm4,mm6             ; unpack to higher precision for accumulation
paddw      mm7,mm3             ; accumulate difference...
paddw      mm7,mm4             ; accumulate difference...

ADD EDX,16
DEC ECX
JNZ .DO16
PXOR MM6,MM6
MOVQ MM0,MM7
PUNPCKLWD MM7,MM6
PUNPCKHWD MM0,MM6
PADDD MM7,MM0
MOVQ MM0,MM7
PSRLQ MM0,32
PADDD MM7,MM0
MOVD [EBX],MM7
ADD EBX,4
ADD ESI,768
POP ECX
DEC ECX
JZ .ENDCORR
JMP .DOONELINE
.ENDCORR:
;ZERO KEYSCOUNT[0..32767]
MOV ECX,32768/4
CLD
MOV EDI,[EAX+KEYSCOUNTADDR]
XOR EAX,EAX
REP STOSD
MOV EAX,[STRUCPOINTER]

; ALL CORRELATION CALCULATED
; 2) DO NUMKEYS TIME->
;    FIND MINCORRELATION - LINENUMBER
;    SET IT TO $FFFFFFFF
;    ADD ABS(ALLKEYS[LINENUMBER,0..32767]-NUMKEYSTIME) TO KEYSCOUNT[0..32767]
;    DEC NUMKEYSTIME
;    LOOP 2
MOV EDX,[EAX+CORRADDR]
;SET KEYLINE-KEYLINE CORRELATION TO MAX
MOV EBX,[EAX+KEYLINE]
SHL EBX,4
ADD EBX,EDX
MOV DWORD [EBX],0FFFFFFFFH
MOV ECX,[EAX+NUMKEYS]
.ADDCOUNTS:
PUSH ECX
;FIND MIN CORRELATION
MOV EDI,[EAX+CORRADDR]
MOV EBX,0FFFFFFFFH
MOV ECX,287
XOR EDX,EDX
.SEARCHMINCORRELATION:
CMP EBX,[EDI]
JB .NOMINCORR
MOV EBX,[EDI]
MOV ESI,EDI
MOV EAX,EDX
.NOMINCORR:
ADD EDI,4
INC EDX
DEC ECX
JNZ .SEARCHMINCORRELATION
MOV EBX,0FFFFFFFFH
MOV [ESI],EBX
MOV ESI,EAX
MOV EAX,[STRUCPOINTER]
;MINCORRELATION FOUND AT LINE NUMBER ESI
;NOW ADD ALLKEYS[ESI,0..32767] TO KEYSCOUNT[0..32767]
MOV EDI,[EAX+ALLKEYSPTR]
SHL ESI,15 ; KEYLINE * 32768 OFFSET IN ALLKEYS
ADD EDI,ESI
MOV ESI,[EAX+KEYSCOUNTADDR]
; [ESI]:=[ESI]+[EDI] - [ESI]WORD [EDI]BYTE
MOV ECX,32768
.ADDBYTES:
MOVQ MM0,[EDI]
MOVQ MM1,[EDI+32]
PADDusb MM0,[ESI]
MOVQ MM2,[EDI+8]
PADDusb MM1,[ESI+32]
MOVQ MM3,[EDI+40]
PADDusb MM2,[ESI+8]
PADDusb MM3,[ESI+40]

MOVQ [ESI],MM0
MOVQ [ESI+32],MM1
MOVQ [ESI+8],MM2
MOVQ [ESI+40],MM3

MOVQ MM4,[EDI+16]
MOVQ MM5,[EDI+24]
PADDusb MM4,[ESI+16]
MOVQ MM6,[EDI+48]
PADDusb MM5,[ESI+24]
MOVQ MM7,[EDI+56]
PADDusb MM6,[ESI+48]
PADDusb MM7,[ESI+56]


MOVQ [ESI+16],MM4
MOVQ [ESI+24],MM5
MOVQ [ESI+48],MM6
MOVQ [ESI+56],MM7

ADD EDI,64
ADD ESI,64
SUB ECX,64
JNZ .ADDBYTES


POP ECX
DEC ECX
JZ .COUNTSFINISHED
JMP .ADDCOUNTS
.COUNTSFINISHED:

; 3) FIND FROM KEYSCOUNT[0..32767] MINIMUM VALUE -> BESTKEY
; 4) CALCULSEQUENCE(BESTKEY)
MOV EDI,[EAX+KEYSCOUNTADDR]
MOV EBX,0FFFFFFFFH
XOR EDX,EDX
MOV ECX,32768
.SEARCHMINKEY:
CMP BL,[EDI]
JB .NOMINKEY
MOV ESI,EDX
MOV BL,[EDI]
.NOMINKEY:
INC EDI
INC EDX
DEC ECX
JNZ .SEARCHMINKEY
;MINKEY VALUE AT ESI
MOV EDI,EAX
MOV EAX,ESI
MOV [EDI+MINKEY],EAX
EMMS
CALL [EDI+CALCULSEQPTR]
;SHOW PICTURE ON SCREEN GIVEN LINEX:=LINE(SEQUENCEBUFFER[X])
MOV EAX,[STRUCPOINTER]
MOV ECX,[EAX+YCOUNT]
MOV EDX,[EAX+SEQPTR]
MOV ESI,[EAX+SCREENPOINTER]

PXOR MM7,MM7

.DOALLLINES:
MOV EDI,[EDX+287*4]
MOV EBX,[EDX+287*8]

mov eax,[edx+287*12]

MOV EBP,96
.ONELINE

cmp eax,0
je .normalcolor
cmp eax,1
je .signex
cmp eax,2
je .sign
cmp eax,3
je .ex

MOVD MM1,[ONLYSIGN]        ; 00 00 00 00 B4 B3 B2 B1
MOVQ MM2,MM1               ; 00 00 00 00 R4 R3 R2 R1
JMP .contcolor
.normalcolor:
MOVD MM1,[EBX]        ; 00 00 00 00 B4 B3 B2 B1
MOVD MM2,[EBX+110208] ; 00 00 00 00 R4 R3 R2 R1
JMP .contcolor
.signex:
MOVD MM2,[EBX]        ; 00 00 00 00 B4 B3 B2 B1
MOVD MM1,[EBX+110208] ; 00 00 00 00 R4 R3 R2 R1
pANDN mm2,[FULLAND]
pANDN mm1,[FULLAND]
JMP .contcolor
.sign:
MOVD MM1,[EBX]        ; 00 00 00 00 B4 B3 B2 B1
MOVD MM2,[EBX+110208] ; 00 00 00 00 R4 R3 R2 R1
pANDN mm1,[FULLAND]
pANDN mm2,[FULLAND]
JMP .contcolor
.ex:
MOVD MM2,[EBX]        ; 00 00 00 00 B4 B3 B2 B1
MOVD MM1,[EBX+110208] ; 00 00 00 00 R4 R3 R2 R1

.contcolor:
MOVQ MM0,[EDI]
MOVQ MM3,MM0          ; Y8 Y7 Y6 Y5 Y4 Y3 Y2 Y1
punpcklbw mm0,mm7     ; 00 y4 00 y3 00 y2 00 y1
punpckhbw mm3,mm7     ; 00 y8 00 y7 00 y6 00 y5

punpcklbw mm1,mm1     ; b4 b4 b3 b3 b2 b2 b1 b1
movq mm4,mm1
punpcklbw mm1,mm7     ; 00 b2 00 b2 00 b1 00 b1
punpckhbw mm4,mm7     ; 00 b4 00 b4 00 b3 00 b3

punpcklbw mm2,mm2
movq mm5,mm2
punpcklbw mm2,mm7     ; 00 r2 00 r2 00 r1 00 r1
punpckhbw mm5,mm7     ; 00 r4 00 r4 00 r3 00 r3

MOVQ MM6,[MINUS128]
PADDUSW MM1,MM0       ; B:=Y+(CB-128)
PADDUSW MM4,MM3
PADDUSW MM2,MM0       ; R:=Y+(CR-128)
PADDUSW MM5,MM3

PSUBUSW MM1,MM6       ;
PSUBUSW MM2,MM6
PSUBUSW MM4,MM6
PSUBUSW MM5,MM6
                      ; G:=1.7Y-0.5R-0.2B
MOVQ MM6,MM0
PSLLW MM0,1
PSRLW MM6,2
PSUBUSW MM0,MM6       ; 1.7Y
MOVQ MM6,MM2
PSRLW MM6,1
PSUBUSW MM0,MM6       ; 0.5 R
MOVQ MM6,MM1
PSRLW MM6,2
PSUBUSW MM0,MM6       ; 0.25B

MOVQ MM6,MM3
PSLLW MM3,1
PSRLW MM6,2
PSUBUSW MM3,MM6       ; 1.7Y
MOVQ MM6,MM5
PSRLW MM6,1
PSUBUSW MM3,MM6       ; 0.5 R
MOVQ MM6,MM4
PSRLW MM6,2
PSUBUSW MM3,MM6       ; 0.25B






;MM0=GREEN
;MM1=BLUE
;MM2=RED
;MM3=GREEN
;MM4=BLUE
;MM5=RED

PSRLW MM0,2
PSRLW MM1,3
PSRLW MM2,3
PSRLW MM3,2
PSRLW MM4,3
PSRLW MM5,3
PSLLW MM0,5
PSLLW MM3,5
PSLLW MM5,11
PSLLW MM2,11
POR MM0,MM1
POR MM0,MM2
POR MM3,MM4
POR MM3,MM5
MOVQ [ESI],MM0
MOVQ [ESI+8],MM3


ADD ESI,16
ADD EDI,8
ADD EBX,4
DEC EBP


JZ .ONELINEEND
JMP .ONELINE
.ONELINEEND

SUB ESI,768*2
ADD ESI,800*4
ADD EDX,4
DEC ECX
JZ .endshow
jmp  .DOALLLINES
.endshow:


emms
POPAD
retn
MINUS16         DD   10101010H, 10101010H
FULLAND         DD   0FFFFFFFFH, 0FFFFFFFFH
BYTEAND         DD   3F3F3F3FH, 3F3F3F3FH
MINUS128        DD   00800080H, 00800080H
ONLYSIGN        DD   80808080H, 80808080H
NOSIGN          DD   7F7F7F7FH, 7F7F7F7FH

