unit SSETUP;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ComCtrls;

type
  TSETUPFORM = class(TForm)
    Label1: TLabel;
    KEYFILE: TComboBox;
    Label2: TLabel;
    BASEADDR: TEdit;
    KEYLINECAP: TLabel;
    KEYLINE: TSpinEdit;
    Label5: TLabel;
    NUMKEYS: TSpinEdit;
    AUDIOENABLED: TCheckBox;
    Button1: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  PROCEDURE READCFGFILE;
  PROCEDURE WRITECFGFILE;

  end;

  SETUPRECORD = RECORD
                KEYFILE :BYTE;
                BASEADDR :DWORD;
                KEYLINE : INTEGER;
                NUMKEYS : INTEGER;
                AUDIO:BOOLEAN;
                VBI:BOOLEAN;
                END;

var
  SETUPFORM: TSETUPFORM;
  SETUPDATA : SETUPRECORD;
  SETUPFILE : FILE OF SETUPRECORD;

  FUNCTION HEXTOINT(HEXSTRING : STRING):DWORD;

  CONST CFGFILE = 'SYSTER.CFG';

implementation

{$R *.DFM}
FUNCTION HEXTOINT(HEXSTRING : STRING):DWORD;
          VAR I,S,Z : LONGINT;
              TS : STRING[8];
BEGIN
TS:=HEXSTRING;
S:=1;
Z:=0;
FOR I:=1 TO 8 DO
              BEGIN
              CASE TS[9-I] OF
              '1' : Z:=Z+S*1;
              '2' : Z:=Z+S*2;
              '3' : Z:=Z+S*3;
              '4' : Z:=Z+S*4;
              '5' : Z:=Z+S*5;
              '6' : Z:=Z+S*6;
              '7' : Z:=Z+S*7;
              '8' : Z:=Z+S*8;
              '9' : Z:=Z+S*9;
              'A' : Z:=Z+S*10;
              'B' : Z:=Z+S*11;
              'C' : Z:=Z+S*12;
              'D' : Z:=Z+S*13;
              'E' : Z:=Z+S*14;
              'F' : Z:=Z+S*15;
              END;
              S:=S*16;
              END;
RESULT:=Z;
END;

PROCEDURE TSETUPFORM.WRITECFGFILE;
BEGIN
SETUPDATA.KEYFILE:=KEYFILE.ITEMINDEX;
SETUPDATA.BASEADDR:=HEXTOINT(BASEADDR.TEXT);

SETUPDATA.KEYLINE:=KEYLINE.VALUE;
SETUPDATA.NUMKEYS:=NUMKEYS.Value;
SETUPDATA.AUDIO:=AUDIOENABLED.Checked;
ASSIGNFILE(SETUPFILE,CFGFILE);
REWRITE(SETUPFILE);
WRITE(SETUPFILE,SETUPDATA);
CLOSEFILE(SETUPFILE);

END;
PROCEDURE TSETUPFORM.READCFGFILE;
BEGIN
  {$I-}
ASSIGNFILE(SETUPFILE,CFGFILE);
RESET(SETUPFILE);
CLOSEFILE(SETUPFILE);
  {$I+}
IF (IOResult = 0)  THEN
BEGIN
ASSIGNFILE(SETUPFILE,CFGFILE);
RESET(SETUPFILE);
READ(SETUPFILE,SETUPDATA);
CLOSEFILE(SETUPFILE);

KEYFILE.ITEMINDEX:=SETUPDATA.KEYFILE;
BASEADDR.TEXT:=INTTOHEX(SETUPDATA.BASEADDR,8);

NUMKEYS.VALUE:=SETUPDATA.NUMKEYS;
KEYLINE.Value:=SETUPDATA.KEYLINE;
AUDIOENABLED.Checked:=SETUPDATA.AUDIO;
END;
END;




procedure TSETUPFORM.FormShow(Sender: TObject);
begin
READCFGFILE;
end;

procedure TSETUPFORM.FormClose(Sender: TObject; var Action: TCloseAction);
begin
WRITECFGFILE;
end;

procedure TSETUPFORM.Button1Click(Sender: TObject);
          VAR ERRORFOUND : BOOLEAN;
begin
    SETUPFORM.CLOSE;
end;

end.
