unit Unit1;

interface

uses
  Windows, SysUtils, Classes, Forms, DIALOGS,
  BT848, vxd, ToolWin,SSETUP,VIDEO, Menus, Controls, StdCtrls,sound;


type
  TForm1 = class(TForm)
    STATLABEL: TLabel;
    PM1: TPopupMenu;
    PSTART: TMenuItem;
    PSTOP: TMenuItem;
    FIELDS1: TMenuItem;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PSTARTClick(Sender: TObject);
    procedure PSTOPClick(Sender: TObject);
    procedure PM1Popup(Sender: TObject);
    procedure FIELDS1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  PROCESSHANDLE,THREADHANDLE : thandle;
  TEMPSTAT,TEMPDWORD : DWORD;
  FCOUNTER,OLDTIME,NEWTIME : LONGINT;
  I,X,Y,Z,R,COMMUNS,MAXCOMMUNS,MAXCOMMUNKEY : LONGINT;
  FIRSTRUN : BOOLEAN;


PROCEDURE INITKEYS;

implementation


{$R *.DFM}

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     CASE KEY OF
          VK_NUMPAD1 : BEGIN  //BRIGHT +
                       TEMPDWORD:=(readbt(@BT848L[BRIGHT]));
                       ASM
                       MOV EAX,TEMPDWORD
                       INC AL
                       MOV TEMPDWORD,EAX
                       END;
                       STATLABEL.CAPTION:='BRIGHTNESS   '+INTTOSTR(SHORTINT(TEMPDWORD));
                       WRITEBT(@BT848L[BRIGHT],TEMPDWORD);
                       END;

          VK_NUMPAD2 : BEGIN  //BRIGHT -
                       TEMPDWORD:=(readbt(@BT848L[BRIGHT]));
                       ASM
                       MOV EAX,TEMPDWORD
                       DEC AL
                       MOV TEMPDWORD,EAX
                       END;
                       STATLABEL.CAPTION:='BRIGHTNESS   '+INTTOSTR(SHORTINT(TEMPDWORD));
                       WRITEBT(@BT848L[BRIGHT],TEMPDWORD);
                       END;
          VK_NUMPAD4 : BEGIN  //hue +
                       TEMPDWORD:=(readbt(@BT848L[HUE]));
                       ASM
                       MOV EAX,TEMPDWORD
                       INC AL
                       MOV TEMPDWORD,EAX
                       END;
                       STATLABEL.CAPTION:='HUE   '+INTTOSTR(SHORTINT(TEMPDWORD));
                       WRITEBT(@BT848L[HUE],TEMPDWORD);
                       END;

          VK_NUMPAD5 : BEGIN  //hue -
                       TEMPDWORD:=(readbt(@BT848L[HUE]));
                       ASM
                       MOV EAX,TEMPDWORD
                       DEC AL
                       MOV TEMPDWORD,EAX
                       END;
                       STATLABEL.CAPTION:='HUE   '+INTTOSTR(SHORTINT(TEMPDWORD));
                       WRITEBT(@BT848L[HUE],TEMPDWORD);
                       END;
          VK_NUMPAD0 : BEGIN  //PHASE
                       PHASESTAT:=PHASESTAT+1;
                       STATLABEL.CAPTION:='PHASE = '+INTTOSTR(LONGINT(PHASESTAT));
                       END;
          VK_NUMPAD7 : BEGIN
                  INC(ASMINFO.NUMKEYS);
                  IF (ASMINFO.NUMKEYS=33) THEN ASMINFO.NUMKEYS:=2;
                  STATLABEL.CAPTION:='LINES TO SEARCH = '+INTTOSTR(ASMINFO.NUMKEYS);
                  END;

          VK_ESCAPE : BEGIN
                      CAPSTOP;
                      IF SETUPDATA.AUDIO=TRUE THEN RESETSOUND;
                      PAGEFREE(BTBUFFERL,0);
                      PAGEFREE(RISCL,0);
                      APPLICATION.TERMINATE;
                      END;
          END;


end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
CAPSTOP;
PAGEFREE(BTBUFFERL,0);
PAGEFREE(RISCL,0);
CLOSEDDRAW;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
IF FIRSTRUN THEN BEGIN
FIRSTRUN:=FALSE;
//ddraw INIT
DDHWND:=FORM1.HANDLE;
INITDDRAW;


//SETUP FORM
SETUPFORM.SHOWMODAL;
SETUPFORM.READCFGFILE;
BT848P:=POINTER(SETUPDATA.BASEADDR);

//VMM VXD SERVICES
INITVXD;
MAPPHYSTOLINEAR(POINTER(BT848P),$2FF);
BT848L:=POINTER(RETURNEAX);
IF DWORD(BT848L)=$FFFFFFFF THEN BEGIN
                                SHOWMESSAGE('Unable to map BT848 Base addr!');
                                APPLICATION.TERMINATE;
                                END;

PAGEALLOCATE(ROUND(SIZEOF(BTBUFFERSTRUC)/4096)+3,PG_SYS,0,0,0,$100000,
             @BTBUFFERP,PAGECONTIG OR PAGEFIXED OR PAGEUSEALIGN);
BTBUFFERL:=POINTER(RETURNEAX);
IF DWORD(BTBUFFERL)=$0 THEN BEGIN
                                SHOWMESSAGE('Unable to allocate physical memory (BTBUFFER)!');
                                ERRORFOUND:=TRUE;
                                END;

PAGEALLOCATE(ROUND(SIZEOF(RISCPRG)/4096)+3,PG_SYS,0,0,0,$100000,
             @RISCP,PAGECONTIG OR PAGEFIXED OR PAGEUSEALIGN);
RISCL:=POINTER(RETURNEAX);
IF DWORD(RISCL)=$0 THEN BEGIN
                                SHOWMESSAGE('Unable to allocate physical memory (RISCPRG)!');
                                ERRORFOUND:=TRUE;
                                END;

PROCESSHANDLE:=GETCURRENTPROCESS;
THREADHANDLE:=GETCURRENTTHREAD;
//SETPRIORITYCLASS(PROCESSHANDLE,REALTIME_PRIORITY_CLASS);
//SETTHREADPRIORITY(THREADHANDLE,THREAD_PRIORITY_TIME_CRITICAL);

APPLICATION.PROCESSMESSAGES;
FORM1.REPAINT;

IF ERRORFOUND THEN FORM1.CLOSE ELSE
BEGIN
capstop;
INITKEYS;
IF SETUPDATA.AUDIO=TRUE THEN INITSOUND;
END;

end;
END;
procedure TForm1.FormCreate(Sender: TObject);
begin
FIRSTRUN:=TRUE;
end;

PROCEDURE INITKEYS;
BEGIN
ERRORFOUND:=FALSE;
ASMINFO.BLOCK16:=48;
SAVETOFILE:=FALSE;
FILENO:=1;
FIELDSELECT:=$0FFFFFFFF;

//INIT ASMINFO STRUC
ASMINFO.SEQPTR:=@SEQUENCEBUFFER[0];
ASMINFO.DOUBLED:=0;
ASMINFO.SCREENBASE:=POINTER(INTEGER(VBASEL)+ROUND(
                  (SCREEN.HEIGHT-574)*(BYTEPERPIXEL/2)*SCREEN.WIDTH+
                  (SCREEN.WIDTH-768)*(BYTEPERPIXEL/2)));
ASMINFO.YCOUNT:=287;
ASMINFO.ALLKEYSPTR:=@ALLKEYS[0,0];
ASMINFO.CALCULSEQPTR:=@CALCULSEQUENCEOFFSET;
ASMINFO.NUMKEYS:=SETUPDATA.NUMKEYS;
ASMINFO.KEYLINE:=SETUPDATA.KEYLINE;
ASMINFO.CORRSADDR:=@CORRELATIONS[0];
ASMINFO.KEYSCOUNTADDR:=@KEYSCOUNT[0];

//LOAD KEYFILE AND TRANSLATE TO BINARY KEYTABLE
form1.statlabel.caption:='Loading key file ';
form1.statlabel.repaint;

KEYS:=TSTRINGLIST.Create;
TRY
KEYS.LoadFromFile(SETUPFORM.KEYFILE.TEXT);
EXCEPT BEGIN
       SHOWMESSAGE(SETUPFORM.KEYFILE.TEXT+' OPEN ERROR !!!');
       KEYS.Free;
       ERRORFOUND:=TRUE;
       END;
END;
FOR I:=0 TO 255 DO KEYTABLE[I]:=BYTE(STRTOINT(KEYS.STRINGS[I]));


IF NOT ERRORFOUND THEN
BEGIN
form1.statlabel.caption:='Preparing KEYS';
form1.statlabel.repaint;

//PREPARE ALLKEYS STRUC

FOR X:=0 TO 32767 DO
BEGIN
IF (X and $f000)=x THEN
BEGIN
FORM1.STATLABEL.CAPTION:=INTTOSTR(X)+' / 32768';
APPLICATION.PROCESSMESSAGES;
END;
CALCULSEQUENCE(X);
FOR I:=0 TO 286 DO IF SEQUENCEBUFFER[I]=SETUPDATA.KEYLINE THEN LINEFORKEY:=I;
FOR I:=0 TO 286 DO BEGIN
                   Y:=ABS(LINEFORKEY-I);
                   IF Y>31 THEN Y:=31;
                   ALLKEYS[SEQUENCEBUFFER[I],X]:=BYTE(Y);
                   END;


END;
P1:=@ALLKEYS[0,0];
form1.statlabel.caption:='Press a mouse button to see menu';
form1.statlabel.repaint;
END;
END;


procedure TForm1.PSTOPClick(Sender: TObject);
begin
INCAPTURE:=FALSE;
CAPSTOP;
PSTART.ENABLED:=TRUE;
PSTOP.ENABLED:=FALSE;
STATLABEL.CAPTION:=INTTOSTR(TRUNC(FCOUNTER*1000/(GETTICKCOUNT-OLDTIME)));
IF SETUPDATA.AUDIO=TRUE THEN STOPSOUND;
end;

procedure TForm1.PSTARTClick(Sender: TObject);
begin
FCOUNTER:=0;
TEMPSTAT:=READSTAT;
OLDTIME:=GETTICKCOUNT;
CAPSTART;
PSTART.ENABLED:=FALSE;
PSTOP.ENABLED:=TRUE;
IF SETUPDATA.AUDIO=TRUE THEN STARTSOUND;
REPEAT
BEGIN
   IF SETUPDATA.AUDIO=TRUE THEN PROCESSSOUND;;
   PROCESSVIDEO;
   INC(FCOUNTER);
END;
UNTIL INCAPTURE=FALSE;

end;

procedure TForm1.PM1Popup(Sender: TObject);
begin
PSTART.ENABLED:=TRUE;
PSTOP.ENABLED:=TRUE;
IF INCAPTURE=TRUE THEN PSTART.Enabled:=FALSE ELSE PSTOP.ENABLED:=FALSE;
end;

procedure TForm1.FIELDS1Click(Sender: TObject);
begin
     FIELDS1.CHECKED:=NOT(FIELDS1.CHECKED);
     CASE FIELDS1.CHECKED OF
          TRUE : FIELDSELECT:=$0FFFFFFFF;
          FALSE :
                BEGIN
                FIELDSELECT:=1;
                P1:=ASMINFO.SCREENBASE;
                ASM
                PUSHAD
                CLD
                XOR EAX,EAX
                MOV EDI,P1
                MOV ESI,P1
                MOV ECX,400*600
                REP STOSD
                POPAD
                END;
                END;
          END;

end;

end.

