unit VIDEO;

interface
USES BT848,WINDOWS,CLASSES,SSETUP,DIALOGS,SYSUTILS,forms,DIRECTX;
{$L \ASM\DVP1.OBJ}


TYPE AUXB=RECORD
         YBUFFER   : ARRAY[1..287,1..768] OF BYTE;
         CBBUFFER  : ARRAY[1..287,1..384] OF BYTE;
         CRBUFFER  : ARRAY[1..287,1..384] OF BYTE;
         END;
ASMINFOSTRUC=RECORD
             SCREENPOINTER : POINTER; //0
             SCREENBASE    : POINTER; //4
             ALLKEYSPTR    : POINTER; //8
             SEQPTR        : POINTER; //12
             AUXPTR        : ^AUXB  ; //16
             CALCULSEQPTR  : POINTER; //20
             EVENORODD     : DWORD;   //24
             DOUBLED       : DWORD;   //28
             YCOUNT        : DWORD;   //32
             MINKEY        : DWORD;   //36
             KEYLINE       : DWORD;   //40
             NUMKEYS       : DWORD;   //44
             BLOCK16       : DWORD;   //48
             CORRSADDR     : POINTER; //52
             KEYSCOUNTADDR : POINTER; //56
             COLORPTR      : POINTER; //60
             FLAGS         : DWORD;
             END;

//ASMSTRUC FLAGS
CONST
EVENORODD    = 1;
ALLFIELDS    = 4;
PHASE        = 16;
FPSENABLED   = 32;
NORMALCOLOR = 128;

CONST BYTEPERPIXEL=2;

VAR

P1,P2 : POINTER;
ASMINFO          : ASMINFOSTRUC;
KEYS             : TSTRINGLIST;
ERRORFOUND       : BOOLEAN;
KEYtable         : ARRAY[0..255] OF BYTE;
SEQUENCEBUFFER   : ARRAY[0..1147] OF LONGINT;
HASHBUFFER       : ARRAY[0..31] OF INTEGER;
OFFSET,INCREMENT : BYTE;
X,Y,Z,I : LONGINT;

KEYINDEX,MINKEYINDEX : LONGINT;
KEYSCOUNT   : ARRAY[0..32767] OF BYTE;
ALLKEYS : ARRAY[0..286,0..32767] OF BYTE;
CORRELATIONS : ARRAY[0..286] OF LONGINT;

KEYSIZE,BLOCKSIZE : LONGINT;
LINEFORKEY : LONGINT;

FIELDSTAT,OLDSTAT : DWORD;
FIELDSTATOK : BOOLEAN;
SAVETOFILE : BOOLEAN;
PHASESTAT : LONGINT;
FILENO     : INTEGER;
FIELDSELECT : DWORD;
DECODEENABLED : BOOLEAN;

    //DDRAW VARIABLES
DDHWND : THANDLE;
    DDRVAL : HRESULT;
    LPDD   : IDIRECTDRAW;
    S : IUNKNOWN;
    DDSD : DDSURFACEDESC;
    LPPRIMARY,LPOVERLAY : IDIRECTDRAWSURFACE;

PROCEDURE PROCVIDEOP(STRUCPOINTER : POINTER);EXTERNAL;

PROCEDURE PROCESSVIDEO;
PROCEDURE CALCULSEQUENCE(KINDEX : LONGINT);
PROCEDURE CALCULSEQUENCEOFFSET(KINDEX : LONGINT);
PROCEDURE INITDDRAW;
PROCEDURE CLOSEDDRAW;


implementation

PROCEDURE INITDDRAW;
BEGIN
DDRVAL:=DIRECTDRAWCREATE(nil,lpdd,S);
IF DDRVAL<>DD_OK THEN SHOWMESSAGE('Cant init DDRAW');
DDRVAL:=LPDD.SetCooperativeLevel(DDHWND,ddscl_EXCLUSIVE OR DDSCL_FULLSCREEN);
IF DDRVAL<>DD_OK THEN SHOWMESSAGE('Cant set cooperative level (ddraw)');
DDRVAL:=LPDD.SetDisplayMode(800,600,16);
IF DDRVAL<>DD_OK THEN SHOWMESSAGE('Cant set display mode (ddraw)');

ddsd.dwSize:=sizeof(ddsd);
ddsd.dwFlags:=ddsd_caps;
ddsd.ddsCaps.dwCaps:=ddscaps_primarysurface;

DDRVAL:=LPDD.CreateSurface(DDSD,LPPRIMARY,S);
IF DDRVAL<>DD_OK THEN SHOWMESSAGE('Cant create primary surface (ddraw)');
ddsd.dwSize:=sizeof(ddsd);
LPPRIMARY.Lock(nil,ddsd,0,0);
IF DDRVAL<>DD_OK THEN SHOWMESSAGE('Cant lock primary surface (ddraw)');
vbasel:=ddsd.lpSurface;
lpprimary.Unlock(vbasel);

END;
PROCEDURE CLOSEDDRAW;
BEGIN
lpprimary._Release;
LPDD._Release;
END;

PROCEDURE CALCULSEQUENCE(KINDEX : LONGINT);
          VAR H : BYTE;
              N : LONGINT;
BEGIN
ASM
MOV EAX,KINDEX
MOV H,AL
SHL AH,1
INC AH
MOV INCREMENT,AH
END;
FOR N:=0 TO 31 DO HASHBUFFER[N]:=-1;
FOR N:=0 TO 254 DO
    BEGIN
    IF HASHBUFFER[KEYTABLE[H]]=-1
       THEN SEQUENCEBUFFER[N]:=KEYTABLE[H]
       ELSE SEQUENCEBUFFER[N]:=HASHBUFFER[KEYTABLE[H]];
    HASHBUFFER[KEYTABLE[H]]:=32+N;
    H:=H+INCREMENT;
    END;
FOR N:=0 TO 31 DO SEQUENCEBUFFER[N+255]:=HASHBUFFER[N];
END;
PROCEDURE CALCULSEQUENCEOFFSET(KINDEX : LONGINT);
          VAR H : BYTE;
              N : LONGINT;
BEGIN
ASM
MOV EAX,KINDEX
MOV H,AL
SHL AH,1
INC AH
MOV INCREMENT,AH
END;
FOR N:=0 TO 31 DO HASHBUFFER[N]:=-1;
FOR N:=0 TO 254 DO
    BEGIN
    IF HASHBUFFER[KEYTABLE[H]]=-1
       THEN SEQUENCEBUFFER[N]:=KEYTABLE[H]
       ELSE SEQUENCEBUFFER[N]:=HASHBUFFER[KEYTABLE[H]];
    HASHBUFFER[KEYTABLE[H]]:=32+N;
    H:=H+INCREMENT;
    END;
FOR N:=0 TO 31 DO SEQUENCEBUFFER[N+255]:=HASHBUFFER[N];
FOR N:=0 TO 286 DO
         BEGIN
         SEQUENCEBUFFER[N+287+287]:=SEQUENCEBUFFER[N]*384+DWORD(ASMINFO.COLORPTR);
         SEQUENCEBUFFER[N+287]:=SEQUENCEBUFFER[N]*768+DWORD(ASMINFO.AUXPTR);
         END;
INC(FIELDSTAT,PHASESTAT);
FOR N:=0 TO 286 DO
IF (SEQUENCEBUFFER[N]<33) {OR
   (32+N-SEQUENCEBUFFER[N]>35) OR
   (32+N-SEQUENCEBUFFER[N]<5)} THEN SEQUENCEBUFFER[N+861]:=4
   ELSE
   IF ((FIELDSTAT-1) AND 2)=0 THEN
      IF (SEQUENCEBUFFER[N] AND 1)=0 THEN SEQUENCEBUFFER[N+861]:=((SEQUENCEBUFFER[N]-N) AND 3)
                                     ELSE BEGIN
                                          SEQUENCEBUFFER[N+861]:=((SEQUENCEBUFFER[N]-N) AND 3);
                                          IF SEQUENCEBUFFER[N+861]=1 THEN SEQUENCEBUFFER[N+861]:=3
                                          ELSE IF SEQUENCEBUFFER[N+861]=3 THEN SEQUENCEBUFFER[N+861]:=1;
                                          END
  ELSE
      IF (SEQUENCEBUFFER[N] AND 1)=1 THEN SEQUENCEBUFFER[N+861]:=((SEQUENCEBUFFER[N]-N) AND 3)
                                     ELSE BEGIN
                                          SEQUENCEBUFFER[N+861]:=((SEQUENCEBUFFER[N]-N) AND 3);
                                          IF SEQUENCEBUFFER[N+861]=1 THEN SEQUENCEBUFFER[N+861]:=3
                                          ELSE IF SEQUENCEBUFFER[N+861]=3 THEN SEQUENCEBUFFER[N+861]:=1;
                                          END;
DEC(FIELDSTAT,PHASESTAT);

END;

PROCEDURE PROCESSVIDEO;
BEGIN
FIELDSTATOK:=FALSE;

REPEAT BEGIN
       APPLICATION.PROCESSMESSAGES;
       FIELDSTAT:=((READSTAT AND $F0000000) SHR 28);
       CASE FIELDSTAT OF
                     1: IF (OLDSTAT<>FIELDSTAT) AND ((FIELDSTAT AND FIELDSELECT)<>0) THEN
                        BEGIN
                        OLDSTAT:=FIELDSTAT;
                        ASMINFO.AUXPTR:=@BTBUFFERL.EVENYBUFFER[1,1];
                        ASMINFO.COLORPTR:=@BTBUFFERL.EVENCBBUFFER[1,1];
                        ASMINFO.EVENORODD:=1;
                        FIELDSTATOK:=TRUE;
                        ASMINFO.SCREENPOINTER:=POINTER(INTEGER(ASMINFO.SCREENBASE)+SCREEN.WIDTH*BYTEPERPIXEL);
                        END;
                     2: IF (OLDSTAT<>FIELDSTAT) AND ((FIELDSTAT AND FIELDSELECT)<>0) THEN
                        BEGIN
                        OLDSTAT:=FIELDSTAT;
                        ASMINFO.AUXPTR:=@BTBUFFERL.ODDYBUFFER[1,1];
                        ASMINFO.COLORPTR:=@BTBUFFERL.ODDCBBUFFER[1,1];
                        ASMINFO.EVENORODD:=0;
                        FIELDSTATOK:=TRUE;
                        ASMINFO.SCREENPOINTER:=ASMINFO.SCREENBASE;
                        END;
                     3: IF (OLDSTAT<>FIELDSTAT) AND ((FIELDSTAT AND FIELDSELECT)<>0) THEN
                        BEGIN
                        OLDSTAT:=FIELDSTAT;
                        ASMINFO.AUXPTR:=@BTBUFFERL.EVENYBUFFER2[1,1];
                        ASMINFO.COLORPTR:=@BTBUFFERL.EVENCBBUFFER2[1,1];
                        ASMINFO.EVENORODD:=1;
                        FIELDSTATOK:=TRUE;
                        ASMINFO.SCREENPOINTER:=POINTER(INTEGER(ASMINFO.SCREENBASE)+SCREEN.WIDTH*BYTEPERPIXEL);
                        END;
                     4: IF (OLDSTAT<>FIELDSTAT) AND ((FIELDSTAT AND FIELDSELECT)<>0) THEN
                        BEGIN
                        OLDSTAT:=FIELDSTAT;
                        ASMINFO.AUXPTR:=@BTBUFFERL.ODDYBUFFER2[1,1];
                        ASMINFO.COLORPTR:=@BTBUFFERL.ODDCBBUFFER2[1,1];
                        ASMINFO.EVENORODD:=0;
                        FIELDSTATOK:=TRUE;
                        ASMINFO.SCREENPOINTER:=ASMINFO.SCREENBASE;
                        END;
       END;
       END;
       UNTIL (FIELDSTATOK=TRUE) OR (INCAPTURE=FALSE);

IF INCAPTURE=TRUE then PROCVIDEOP(@ASMINFO);

END;

end.


