unit sound;
interface
uses
  Windows,mmsystem;
{$L \ASM\SNDDEC.OBJ}

CONST SAMPLESHZ=44100;
      SAMPLEBITS=16;
      SAMPLEBYTE=2;
      CHANNELS=1;
      BLOCKALIGN=CHANNELS*SAMPLEBYTE;
      AVERAGEBYTE=SAMPLESHZ*BLOCKALIGN;
      bufferlength=16000;
type
  decodesoundstruc = record
                     inbuffer : pointer;
                     outbuffer : pointer;
                     sinbuffer : pointer;
                     count     : longint;
                     end;
var
  STOPPED : BOOLEAN;
  WAVEINCAPS : TWAVEINCAPSA;
  WAVEINhandle,WAVEOUTHANDLE,HANDLE : INTEGER;
  waveinformat : twaveformatex;
  waveoutformat : twaveformatex;
  openresult : BYTE;

  RETURNVALUE : LONGINT;
  i,x : longint;
  stepc : real;

  SINBUFFER : ARRAY[1..BUFFERLENGTH] OF WORD;
  SINREAL : EXTENDED;SINLONG,SINI : LONGINT;
              DIFF1,DIFF2 : LONGINT;

  WAVEINBUFFERS  : ARRAY[1..3,1..BUFFERLENGTH] OF SMALLINT;
  WAVEOUTBUFFERS : ARRAY[1..3,1..BUFFERLENGTH] OF SMALLINT;
  WAVEINHEADERS  : ARRAY[1..3] OF TWAVEHDR;
  WAVEOUTHEADERS : ARRAY[1..3] OF TWAVEHDR;

  soundstruc : decodesoundstruc;

procedure initsound;
PROCEDURE PROCESSSOUND;
procedure startsound;
procedure stopsound;
procedure resetsound;

PROCEDURE SOUNDDECODE(STRUCPOINTER : POINTER);EXTERNAL;

implementation
procedure startsound;
begin
waveinstart(waveinhandle);
FOR I:=1 TO 3 DO
BEGIN
WAVEINPREPAREHEADER(WAVEINHANDLE,@WAVEINHEADERS[I],SIZEOF(WAVEINHEADERS[I]));
waveinaddbuffer(WAVEINHANDLE,@WAVEINHEADERS[I],SIZEOF(WAVEINHEADERS[I]));
WAVEOUTPREPAREHEADER(WAVEOUTHANDLE,@WAVEOUTHEADERS[I],SIZEOF(TWAVEHDR));
END;
end;
procedure stopsound;
begin
waveinreset(waveinhandle);
waveoutreset(waveouthandle);
end;
procedure INITSOUND;
begin
     SOUNDSTRUC.count:=(BUFFERLENGTH SHR 3);
     SOUNDSTRUC.sinbuffer:=@SINBUFFER[1];

     SINREAL:=25600/88200;
     FOR SINI:=1 TO BUFFERLENGTH DO
         BEGIN
         SINLONG:=ROUND(((2*SINI)-1)*SINREAL);
         IF ROUND(SINLONG/2)*2<>SINLONG THEN SINBUFFER[SINI]:=0 ELSE SINBUFFER[SINI]:=$FFFF;
         END;

     //OPEN WAVEIN DEVICE//
     waveinformat.wFormatTag:=wave_format_pcm;
     waveinformat.nChannels:=CHANNELS;
     waveinformat.nSamplesPerSec:=SAMPLESHZ;
     waveinformat.nAvgBytesPerSec:=AVERAGEBYTE;
     waveinformat.nBlockAlign:=BLOCKALIGN;
     waveinformat.wBitsPerSample:=SAMPLEBITS;
     waveinformat.cbSize:=0;

     RETURNVALUE:=WAVEoutOPEN(@waveouthandle,wave_mapper,@waveinformat,0,0,callback_null);

     RETURNVALUE:=WAVEinOPEN(@waveinhandle,wave_mapper,@waveinformat,0,0,callback_null);

     FOR I:=1 TO 3 DO
     BEGIN
     WAVEINHEADERS[I].LPDATA:=@WAVEINBUFFERS[I,1];
     WAVEINHEADERS[I].DWBUFFERLENGTH:=BUFFERLENGTH;
     WAVEINHEADERS[I].DWFLAGS:=0;
     WAVEINHEADERS[I].DWUSER:=I;
     END;
     FOR I:=1 TO 3 DO
     BEGIN
     WAVEOUTHEADERS[I].LPDATA:=@WAVEOUTBUFFERS[I,1];
     WAVEOUTHEADERS[I].DWBUFFERLENGTH:=BUFFERLENGTH;
     WAVEOUTHEADERS[I].DWFLAGS:=0;
     WAVEOUTHEADERS[I].DWUSER:=I;
     END;

end;
PROCEDURE PROCESSSOUND;
BEGIN
FOR I:=1 TO 3 DO IF WAVEINHEADERS[I].DWFLAGS AND WHDR_DONE=WHDR_DONE THEN
        BEGIN
        SOUNDSTRUC.inbuffer:=@WAVEINBUFFERS[I,1];
        SOUNDSTRUC.outbuffer:=@WAVEOUTBUFFERS[I,1];
        SOUNDDECODE(@SOUNDSTRUC);
{        FOR X:=3 TO BUFFERLENGTH-2 DO
        begin
        stepc:=WAVEOUTBUFFERS[I,X-2]+WAVEOUTBUFFERS[I,X-1]+
               WAVEOUTBUFFERS[I,X+1]+WAVEOUTBUFFERS[I,X+2];
        if stepc<>0 then WAVEOUTBUFFERS[I,X]:=ROUND(stepc/4);
        end;
{        FOR X:=2 TO BUFFERLENGTH-1 DO
            WAVEOUTBUFFERS[I,X]:=ROUND((WAVEOUTBUFFERS[I,X-1]+
                                       2*WAVEOUTBUFFERS[I,X]+
                                       WAVEOUTBUFFERS[I,X+1])/4);
        FOR X:=3 TO BUFFERLENGTH-2 DO
            WAVEOUTBUFFERS[I,X]:=ROUND((WAVEOUTBUFFERS[I,X-2]+
                                       2*WAVEOUTBUFFERS[I,X-1]+
                                       3*WAVEOUTBUFFERS[I,X]+
                                       2*WAVEOUTBUFFERS[I,X+1]+
                                       WAVEOUTBUFFERS[I,X+2])/9);
}
        //WAVEINUNPREPAREHEADER(WAVEINHANDLE,@WAVEINHEADERS[I],SIZEOF(TWAVEHDR));
        //WAVEOUTPREPAREHEADER(WAVEOUTHANDLE,@WAVEOUTHEADERS[I],SIZEOF(TWAVEHDR));
        WAVEOUTWRITE(WAVEOUTHANDLE,@WAVEOUTHEADERS[I],SIZEOF(TWAVEHDR));
        //WAVEINPREPAREHEADER(WAVEINHANDLE,@WAVEINHEADERS[I],SIZEOF(TWAVEHDR));
        WAVEINADDBUFFER(WAVEINHANDLE,@WAVEINHEADERS[I],SIZEOF(TWAVEHDR));
        END;
END;

procedure resetsound;
begin
waveinreset(waveinhandle);
waveoutreset(waveouthandle);
waveinclose(waveinhandle);
waveoutclose(waveouthandle);
end;

end.
