unit VXD;

interface
USES  WINDOWS;

CONST
PAGEZEROINIT    =     $00000001;
PAGEUSEALIGN    =     $00000002;
PAGECONTIG      =     $00000004;
PAGEFIXED       =     $00000008;
PAGEDEBUGNULFAULT       =     $00000010;
PAGEZEROREINIT  =     $00000020;
PAGENOCOPY      =     $00000040;
PAGELOCKED      =     $00000080;
PAGELOCKEDIFDP  =     $00000100;
PAGESETV86PAGEABLE      =     $00000200;
PAGECLEARV86PAGEABLE    =     $00000400;
PAGESETV86INTSLOCKED    =     $00000800;
PAGECLEARV86INTSLOCKED  =     $00001000;
PAGEMARKPAGEOUT =     $00002000;
PAGEPDPSETBASE  =     $00004000;
PAGEPDPCLEARBASE        =     $00008000;
PAGEDISCARD     =     $00010000;
PAGEPDPQUERYDIRTY       =     $00020000;
PAGEMAPFREEPHYSREG      =     $00040000;
PAGEPHYSONLY    =     $04000000;
PAGENOMOVE      =     $10000000;
PAGEMAPGLOBAL   =     $40000000;
PAGEMARKDIRTY   =     $80000000;
MAPV86_IGNOREWRAP       =     $00000001;
MPL_NonCached   =     $00000000;
MPL_HardwareCoherentCached      =     $0000001;
MPL_FrameBufferCached   =     $0000002;
MPL_Cached      =     $0000004;

PG_VM           =     0;
PG_SYS          =     1;
PG_RESERVED1    =     2;
PG_PRIVATE      =     3;
PG_RESERVED2    =     4;
PG_RELOCK       =     5;
PG_INSTANCE     =     6;
PG_HOOKED       =     7;
PG_IGNORE       =     $0FFFFFFFF;

ALIGNMASK4K     =     0;
ALIGNMASK8K     =     1;
ALIGNMASK16K    =     3;
ALIGNMASK32K    =     7;
ALIGNMASK64K    =    $F;
ALIGNMASK128K   =   $1F;

_pageallocatelist = $53;
_pagefreelist     = $55;
_mapphystolinlist = $6c;


VAR
VMMBASE,PROCLISTBASE : POINTER;

RETURNEAX,RETURNEBX,RETURNECX,RETURNEDX,RETURNESI,RETURNEDI : DWORD;
ARGARRAY : ARRAY[0..20] OF DWORD;
ARGPOINTER : POINTER;
_PAGEALLOCATEADDR : POINTER;
_PAGEFREEADDR : POINTER;
_MAPPHYSTOLINEARADDR : POINTER;

PROCEDURE INITVXD;
PROCEDURE PAGEALLOCATE(NPAGES,PTYPE,VM,ALIGNMASK,MINPHYS,MAXPHYS : DWORD;PHYSADDR : POINTER;FLAGS : DWORD);
PROCEDURE PAGEFREE(LINEARADDR : POINTER;FLAGS : DWORD);
PROCEDURE MAPPHYSTOLINEAR(PHYSADDR : POINTER;NBYTES : DWORD);
PROCEDURE CALLRING0PROC;EXTERNAL;

implementation
{$L RING0}

PROCEDURE INITVXD;
BEGIN
ARGPOINTER:=@ARGARRAY;
VMMBASE:=POINTER(0);
ASM
PUSHAD
CLD
MOV EDI,$C0001000
MOV EAX,$204D4D56
MOV EBX,$20202020
MOV ECX,$FFFFFF
@@SEARCHVMM:
CMP EAX,[EDI]
JE @@FOUNDPART1
ADD EDI,4
LOOP @@SEARCHVMM
JMP @@NOTFOUND
@@FOUNDPART1:
CMP EBX,[EDI+4]
JE @@FOUNDPART2
ADD EDI,4
LOOP @@SEARCHVMM
JMP @@NOTFOUND
@@FOUNDPART2:
MOV VMMBASE,EDI
ADD EDI,$24
MOV EAX,[EDI]
MOV PROCLISTBASE,EAX
MOV EDI,EAX
MOV EAX,[EDI+4*_pageallocatelist]
MOV _PAGEALLOCATEADDR,EAX
MOV EAX,[EDI+4*_pagefreelist]
MOV _PAGEFREEADDR,EAX
MOV EAX,[EDI+4*_mapphystolinlist]
MOV _MAPPHYSTOLINEARADDR,EAX
@@NOTFOUND:
POPAD
END;
END;

PROCEDURE PAGEALLOCATE(NPAGES,PTYPE,VM,ALIGNMASK,MINPHYS,MAXPHYS : LONGINT;PHYSADDR : POINTER;FLAGS : LONGINT);
BEGIN
ARGARRAY[0]:=8;
ARGARRAY[1]:=FLAGS;
ARGARRAY[2]:=INTEGER(PHYSADDR);
ARGARRAY[3]:=MAXPHYS;
ARGARRAY[4]:=MINPHYS;
ARGARRAY[5]:=ALIGNMASK;
ARGARRAY[6]:=VM;
ARGARRAY[7]:=PTYPE;
ARGARRAY[8]:=NPAGES;
ASM
PUSHAD
PUSH _PAGEALLOCATEADDR
MOV ESI,ARGPOINTER
CALL CALLRING0PROC
MOV RETURNEAX,EAX
MOV RETURNEBX,EBX
MOV RETURNECX,ECX
MOV RETURNEDX,EDX
MOV RETURNESI,ESI
MOV RETURNEDI,EDI
POPAD
END;
END;
PROCEDURE PAGEFREE(LINEARADDR : POINTER;FLAGS : DWORD);
BEGIN
ARGARRAY[0]:=2;
ARGARRAY[1]:=FLAGS;
ARGARRAY[2]:=INTEGER(LINEARADDR);
ASM
PUSHAD
PUSH _PAGEFREEADDR
MOV ESI,ARGPOINTER
CALL CALLRING0PROC
MOV RETURNEAX,EAX
MOV RETURNEBX,EBX
MOV RETURNECX,ECX
MOV RETURNEDX,EDX
MOV RETURNESI,ESI
MOV RETURNEDI,EDI
POPAD
END;
END;
PROCEDURE MAPPHYSTOLINEAR(PHYSADDR : POINTER;NBYTES : DWORD);
BEGIN
ARGARRAY[0]:=3;
ARGARRAY[1]:=0;
ARGARRAY[2]:=NBYTES;
ARGARRAY[3]:=INTEGER(PHYSADDR);
ASM
PUSHAD
PUSH _MAPPHYSTOLINEARADDR
MOV ESI,ARGPOINTER
CALL CALLRING0PROC
MOV RETURNEAX,EAX
MOV RETURNEBX,EBX
MOV RETURNECX,ECX
MOV RETURNEDX,EDX
MOV RETURNESI,ESI
MOV RETURNEDI,EDI
POPAD
END;
END;

end.
